# LikeDM_v1.0

LikeDM is a likelihood calculator of dark matter detection. 

The basic function of LikeDM is 
to deal with the intermediate steps between the input dark matter model and the
data. It enables fast computation of the likelihood of a given dark matter model (mass, cross section
or decay rate, annihilation or decay yield spectrum), without digging into
the details of cosmic-ray propagation, Fermi-LAT data analysis, and related 
astrophysical backgrounds.

##LikeDM material

- [Latest version](https://github.com/LikeDM/LikeDM_v1.0)

>You might want to download it from 

>[LikeDM@hepforge](https://likedm.hepforge.org/)

- [Manual](http://arxiv.org/abs/1603.07119)

>LikeDM: likelihood calculator of dark matter detection   
Xiaoyuan Huang, Yue-Lin Sming Tsai, Qiang Yuan   
[arXiv:1603.07119](http://arxiv.org/abs/1603.07119)

The currently released version (v1.0) contains only the indirect ditection 
part, including

- the electron/positron measurements by AMS-02,
- the antiproton measurements by PAMELA, and 
- the gamma-ray observations from dwarf spheroidal satellite galaxies by Fermi-LAT.
 

Further developments with more data, e.g., from the gamma-ray observations of the Galactic center and isotropic background, as well as the underground direct detection data, will be carried out soon.

Authors:

Xiaoyuan Huang ([huangxiaoyuan@gmail.com](huangxiaoyuan@gmail.com))   
Yue-Lin Sming Tsai ([smingtsai@gmail.com](smingtsai@gmail.com))   
Qiang Yuan ([yuanq@pmo.ac.cn](yuanq@pmo.ac.c))
